# -*- coding: utf-8 -*-
import random
from random import choice

import c4d
from c4d import documents

from smartstairspackage.utils import smart

from smartstairspackage import config
from smartstairspackage import ids


class Stair(object):
    
    __obj = None
    __data = None
    
    @property
    def obj(self):
        return self.__obj
    @obj.setter
    def obj(self, val):
        self.__data = self.__obj.GetDataInstance()
        self.__obj = val
        
    @property
    def data(self):
        return self.__data
    @data.setter
    def data(self, val):
        self.__data = val
        
    @property
    def child(self):
        return None if not self.is_parent else Stair(self.__obj.GetDown())
    @child.setter
    def child(self, val):
        pass
    
    @property
    def parent(self):
        return None if not self.is_child else Stair(self.__obj.GetUp())
    @child.setter
    def child(self, val):
        pass
    
    @property
    def first(self):
        return self if not self.is_child else self.parent.first
    @first.setter
    def first(self, val):
        pass
    
    __is_child = False
    @property
    def is_child(self):
        self.__is_child = smart.checkIsType(self.__obj.GetUp(), ids.PLUGIN_ID)
        if self.__is_child and self.stairtype == ids.SMARTSTAIRS_STAIRS_TYPE_HELIX:
            self.__is_child = False
        return self.__is_child
    @is_child.setter
    def is_child(self, val):
        pass
        
    __is_parent = False
    @property
    def is_parent(self):
        self.__is_parent = smart.checkIsType(self.__obj.GetDown(), ids.PLUGIN_ID)
        if self.__is_parent and self.stairtype == ids.SMARTSTAIRS_STAIRS_TYPE_HELIX:
            self.__is_parent = False
        if self.__is_parent and self.__obj.GetDown() is not None:
            if self.__obj.GetDown()[ids.SMARTSTAIRS_STAIRS_TYPE] == ids.SMARTSTAIRS_STAIRS_TYPE_HELIX:
                self.__is_parent = False
        return self.__is_parent
    @is_parent.setter
    def is_parent(self, val):
        pass
    """
    __lowest_y = False
    @property
    def lowest_y(self):
        y = 9999999999999
        if self.is_child:
            parent = self.parent
            while parent:
                ty = parent.obj.GetMg().off.y
                if ty < y:
                    y = ty                
                if parent.is_child:
                    parent = parent.parent
                else:
                    break
                  
        if self.is_parent:
            child = self.child
            while child:
                ty = child.obj.GetMg().off.y
                if ty < y:
                    y = ty                
                if child.is_parent:
                    child = child.child
                else:
                    break  
        
        return y
    @lowest_y.setter
    def lowest_y(self, val):
        pass
    """    

    __width = 0
    @property
    def width(self):
        self.__width = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_WIDTH)
        if self.__width < 0.001: self.__width = 0.001
        return self.__width
    @width.setter
    def width(self, val):
        self.__width = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_WIDTH, self.__width)

    __height = 0
    @property
    def height(self):
        self.__height = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_HEIGHT)
        if self.__data.GetBool(ids.SMARTSTAIRS_STAIRS_SDIMS):
            self.__height = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_SHEIGHT) * self.num_steps
            self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_HEIGHT, self.__height) 
        else:
            self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_SHEIGHT, self.__height / self.num_steps)
        if self.__height < 0.001: self.__height = 0.001 
        return self.__height
    @height.setter
    def height(self, val):
        self.__height = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_HEIGHT, self.__height)

    __depth = 0
    @property
    def depth(self):
        self.__depth = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_DEPTH)
        if self.__data.GetBool(ids.SMARTSTAIRS_STAIRS_SDIMS) and not self.stairtype == ids.SMARTSTAIRS_STAIRS_TYPE_HELIX:
            self.__depth = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_SDEPTH) * self.num_steps
            self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_DEPTH, self.__depth)
        else:
            self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_SDEPTH, self.__depth / self.num_steps)
        if self.__depth < 0.001: self.__depth = 0.001 
        return self.__depth
    @depth.setter
    def depth(self, val):
        self.__depth = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_DEPTH, self.__depth)
        
    __use_step_dims = False
    @property
    def use_step_dims(self):
        self.__use_step_dims = self.__data.GetBool(ids.SMARTSTAIRS_STAIRS_SDIMS)
        return self.__use_step_dims
    @use_step_dims.setter
    def use_step_dims(self, val):
        self.__use_step_dims = val
        self.__data.SetBool(ids.SMARTSTAIRS_STAIRS_SDIMS, self.__use_step_dims)

    __num_steps = 10
    @property
    def num_steps(self):
        self.__num_steps = self.__data.GetLong(ids.SMARTSTAIRS_STAIRS_NUM)
        if self.__num_steps < 1: self.__num_steps = 1
        return self.__num_steps
    @num_steps.setter
    def num_steps(self, val):
        self.__num_steps = val
        self.__data.SetLong(ids.SMARTSTAIRS_STAIRS_NUM, self.__num_steps)

    __reverse = False
    @property
    def reverse(self):
        self.__reverse = self.__data.GetBool(ids.SMARTSTAIRS_STAIRS_REVERSE)
        return self.__reverse
    @reverse.setter
    def reverse(self, val):
        self.__reverse = val
        self.__data.SetBool(ids.SMARTSTAIRS_STAIRS_REVERSE, self.__reverse)
        
    __stair_anchor = 0
    @property
    def stair_anchor(self):
        self.__stair_anchor = self.__data.GetLong(ids.SMARTSTAIRS_STAIRS_ANCHOR)
        return self.__stair_anchor
    @stair_anchor.setter
    def stair_anchor(self, val):
        self.__stair_anchor = val
        self.__data.SetLong(ids.SMARTSTAIRS_STAIRS_ANCHOR, self.__stair_anchor)
        
    __inherit_type = False
    @property
    def inherit_type(self):
        self.__inherit_type = self.__data.GetBool(ids.SMARTSTAIRS_TYPE_INHERIT)
        return self.__inherit_type
    @inherit_type.setter
    def inherit_type(self, val):
        self.__inherit_type = val
        self.__data.SetBool(ids.SMARTSTAIRS_TYPE_INHERIT, self.__inherit_type)

    __stairtype = 0
    @property
    def stairtype(self):
        self.__stairtype = self.__data.GetLong(ids.SMARTSTAIRS_STAIRS_TYPE)
        return self.__stairtype
    @stairtype.setter
    def stairtype(self, val):
        self.__stairtype = val
        self.__data.SetLong(ids.SMARTSTAIRS_STAIRS_TYPE, self.__stairtype)
        
    __stair_zigzag = False
    @property
    def stair_zigzag(self):
        self.__stair_zigzag = self.__data.GetBool(ids.SMARTSTAIRS_STAIRS_ZIGZAG)
        return self.__stair_zigzag
    @stair_zigzag.setter
    def stair_zigzag(self, val):
        self.__stair_zigzag = val
        self.__data.SetBool(ids.SMARTSTAIRS_STAIRS_ZIGZAG, self.__stair_zigzag)
        
    __stair_tobottom = False
    @property
    def stair_tobottom(self):
        self.__stair_tobottom = self.__data.GetBool(ids.SMARTSTAIRS_STAIRS_TOBOTTOM)
        return self.__stair_tobottom
    @stair_tobottom.setter
    def stair_tobottom(self, val):
        self.__stair_tobottom = val
        self.__data.SetBool(ids.SMARTSTAIRS_STAIRS_TOBOTTOM, self.__stair_tobottom)
        
    __stair_bottomoffset = 0
    @property
    def stair_bottomoffset(self):
        self.__stair_bottomoffset = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_BOTTOMOFFSET)
        return self.__stair_bottomoffset
    @stair_bottomoffset.setter
    def stair_bottomoffset(self, val):
        self.__stair_bottomoffset = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_BOTTOMOFFSET, self.__stair_bottomoffset)
        
    __stair_helix_deg = 0
    @property
    def stair_helix_deg(self):
        self.__stair_helix_deg = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_HELIX_DEG)
        return self.__stair_helix_deg
    @stair_helix_deg.setter
    def stair_helix_deg(self, val):
        self.__stair_helix_deg = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_HELIX_DEG, self.__stair_helix_deg)
        
    __stair_helix_innerrad = 0
    @property
    def stair_helix_innerrad(self):
        self.__stair_helix_innerrad = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_HELIX_INRAD)
        if self.__stair_helix_innerrad < 0: self.__stair_helix_innerrad = 0
        return self.__stair_helix_innerrad
    @stair_helix_innerrad.setter
    def stair_helix_innerrad(self, val):
        self.__stair_helix_innerrad = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_HELIX_INRAD, self.__stair_helix_innerrad)
        
    __stair_helix_hascyl = False
    @property
    def stair_helix_hascyl(self):
        self.__stair_helix_hascyl = self.__data.GetBool(ids.SMARTSTAIRS_STAIRS_HELIX_HASCYL)
        return self.__stair_helix_hascyl
    @stair_helix_hascyl.setter
    def stair_helix_hascyl(self, val):
        self.__stair_helix_hascyl = val
        self.__data.SetBool(ids.SMARTSTAIRS_STAIRS_HELIX_HASCYL, self.__stair_helix_hascyl)
        
    __stair_helix_cylrad = 0
    @property
    def stair_helix_cylrad(self):
        self.__stair_helix_cylrad = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_HELIX_CYLRAD)
        if self.__stair_helix_cylrad < 0: self.__stair_helix_cylrad = 0
        return self.__stair_helix_cylrad
    @stair_helix_cylrad.setter
    def stair_helix_cylrad(self, val):
        self.__stair_helix_cylrad = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_HELIX_CYLRAD, self.__stair_helix_cylrad)
        
    __inherit_treads = False
    @property
    def inherit_treads(self):
        self.__inherit_treads = self.__data.GetBool(ids.SMARTSTAIRS_TREADS_INHERIT)
        return self.__inherit_treads
    @inherit_treads.setter
    def inherit_treads(self, val):
        self.__inherit_treads = val
        self.__data.SetBool(ids.SMARTSTAIRS_TREADS_INHERIT, self.__inherit_treads)

    __has_treads = False
    @property
    def has_treads(self):
        self.__has_treads = self.__data.GetBool(ids.SMARTSTAIRS_STAIRS_HASTREADS)
        if self.stairtype == ids.SMARTSTAIRS_STAIRS_TYPE_TREADS:
            self.__has_treads = True
        return self.__has_treads
    @has_treads.setter
    def has_treads(self, val):
        self.__has_treads = val
        self.__data.SetBool(ids.SMARTSTAIRS_STAIRS_HASTREADS, self.__has_treads)

    __base_width = 0
    @property
    def base_width(self):
        self.__base_width = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_BASEWIDTH)
        if self.__base_width < 0: self.__base_width = 0
        return self.__base_width
    @base_width.setter
    def base_width(self, val):
        self.__base_width = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_BASEWIDTH, self.__base_width)

    __base_height = 0
    @property
    def base_height(self):
        self.__base_height = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_BASEHEIGHT)
        if self.__base_height < 0: self.__base_height = 0
        return self.__base_height
    @base_height.setter
    def base_height(self, val):
        self.__base_height = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_BASEHEIGHT, self.__base_height)

    __base_distance = 0
    @property
    def base_distance(self):
        self.__base_distance = self.__data.GetReal(ids.SMARTSTAIRS_STAIRS_BASEDISTANCE)
        if self.__base_distance < 0: self.__base_distance = 0
        return self.__base_distance
    @base_distance.setter
    def base_distance(self, val):
        self.__base_distance = val
        self.__data.SetReal(ids.SMARTSTAIRS_STAIRS_BASEDISTANCE, self.__base_distance)

    __treads_height = 0
    @property
    def treads_height(self):
        self.__treads_height = self.__data.GetReal(ids.SMARTSTAIRS_TREADS_HEIGHT)
        if self.__treads_height < 0: 
            self.__treads_height = 0
            self.__data.SetReal(ids.SMARTSTAIRS_TREADS_HEIGHT, self.__treads_height)
            
        if self.__treads_height > self.step_dims.y: 
            self.__treads_height = self.step_dims.y - 0.001
            self.__data.SetReal(ids.SMARTSTAIRS_TREADS_HEIGHT, self.__treads_height)
            
        return self.__treads_height if self.has_treads else 0
    @treads_height.setter
    def treads_height(self, val):
        self.__treads_height = val
        self.__data.SetReal(ids.SMARTSTAIRS_TREADS_HEIGHT, self.__treads_height)

    __treads_depth = 0
    @property
    def treads_depth(self):
        self.__treads_depth = self.__data.GetReal(ids.SMARTSTAIRS_TREADS_DEPTH)
        if self.__treads_depth < 0: self.__treads_depth = 0
        return self.__treads_depth
    @treads_depth.setter
    def treads_depth(self, val):
        self.__treads_depth = val
        self.__data.SetReal(ids.SMARTSTAIRS_TREADS_DEPTH, self.__treads_depth)

    __treads_offset_z = 0
    @property
    def treads_offset_z(self):
        self.__treads_offset_z = self.__data.GetReal(ids.SMARTSTAIRS_TREADS_OFFSETZ)
        if self.__treads_offset_z < 0: self.__treads_offset_z = 0
        return self.__treads_offset_z
    @treads_offset_z.setter
    def treads_offset_z(self, val):
        self.__treads_offset_z = val
        self.__data.SetReal(ids.SMARTSTAIRS_TREADS_OFFSETZ, self.__treads_offset_z)
    __treads_offset_z_y = 0
    
    @property
    def treads_offset_y(self):
        self.__treads_offset_y = self.__data.GetReal(ids.SMARTSTAIRS_TREADS_OFFSETY)
        if self.__treads_offset_y < 0: self.__treads_offset_y = 0
        return self.__treads_offset_y
    @treads_offset_y.setter
    def treads_offset_y(self, val):
        self.__treads_offset_y = val
        self.__data.SetReal(ids.SMARTSTAIRS_TREADS_OFFSETY, self.__treads_offset_y)

    __treads_have_fillet = False
    @property
    def treads_have_fillet(self):
        self.__treads_have_fillet = self.__data.GetBool(ids.SMARTSTAIRS_TREADS_HASFILLET)
        return self.__treads_have_fillet
    @treads_have_fillet.setter
    def treads_have_fillet(self, val):
        self.__treads_have_fillet = val
        self.__data.SetBool(ids.SMARTSTAIRS_TREADS_HASFILLET, self.__treads_have_fillet)

    __treads_fillet_rad = 0
    @property
    def treads_fillet_rad(self):
        self.__treads_fillet_rad = self.__data.GetReal(ids.SMARTSTAIRS_TREADS_FILLETRAD)
        if self.__treads_fillet_rad < 0: self.__treads_fillet_rad = 0
        return self.__treads_fillet_rad
    @treads_fillet_rad.setter
    def treads_fillet_rad(self, val):
        self.__treads_fillet_rad = val
        self.__data.SetReal(ids.SMARTSTAIRS_TREADS_FILLETRAD, self.__treads_fillet_rad)

    __treads_fillet_sub = 0
    @property
    def treads_fillet_sub(self):
        self.__treads_fillet_sub = self.__data.GetLong(ids.SMARTSTAIRS_TREADS_FILLETSUB)
        if self.__treads_fillet_sub < 0: self.__treads_fillet_sub = 0
        return self.__treads_fillet_sub
    @treads_fillet_sub.setter
    def treads_fillet_sub(self, val):
        self.__treads_fillet_sub = val
        self.__data.SetLong(ids.SMARTSTAIRS_TREADS_FILLETSUB, self.__treads_fillet_sub)
        
    __treads_link = False
    @property
    def treads_link(self):
        self.__treads_link = self.__data.GetLink(ids.SMARTSTAIRS_TREADS_LINK, self.__obj.GetDocument())
        return self.parent.treads_link if self.is_child and self.inherit_treads else self.__treads_link
    @treads_link.setter
    def treads_link(self, val):
        self.__treads_link = val
        self.__data.SetLink(ids.SMARTSTAIRS_TREADS_LINK, val)
        
    __treads_link_scale = False
    @property
    def treads_link_scale(self):
        self.__treads_link_scale = self.__data.GetBool(ids.SMARTSTAIRS_TREADS_LINKSCALE)
        return self.__treads_link_scale
    @treads_link_scale.setter
    def treads_link_scale(self, val):
        self.__treads_link_scale = val
        self.__data.SetBool(ids.SMARTSTAIRS_TREADS_LINKSCALE, self.__treads_link_scale)
        
    __inherit_railing = False
    @property
    def inherit_railing(self):
        self.__inherit_railing = self.__data.GetBool(ids.SMARTSTAIRS_RAILING_INHERIT)
        return self.__inherit_railing
    @inherit_railing.setter
    def inherit_railing(self, val):
        self.__inherit_railing = val
        self.__data.SetBool(ids.SMARTSTAIRS_RAILING_INHERIT, self.__inherit_railing)
        
    __has_railing = False
    @property
    def has_railing(self):
        self.__has_railing = self.__data.GetBool(ids.SMARTSTAIRS_STAIRS_HASRAILING)
        return self.__has_railing
    @has_railing.setter
    def has_railing(self, val):
        self.__has_railing = val
        self.__data.SetBool(ids.SMARTSTAIRS_STAIRS_HASRAILING, self.__has_railing)
              
    __railing_type = 0
    @property
    def railing_type(self):
        self.__railing_type = self.__data.GetLong(ids.SMARTSTAIRS_RAILING_TYPE)
        return self.__railing_type
    @railing_type.setter
    def railing_type(self, val):
        self.__railing_type = val
        self.__data.SetLong(ids.SMARTSTAIRS_RAILING_TYPE, self.__railing_type)    
        
    __railing_height = 0
    @property
    def railing_height(self):
        self.__railing_height = self.__data.GetReal(ids.SMARTSTAIRS_RAILING_HEIGHT)
        if self.__railing_height < 0: self.__railing_height = 0
        return self.__railing_height
    @railing_height.setter
    def railing_height(self, val):
        self.__railing_height = val
        self.__data.SetReal(ids.SMARTSTAIRS_RAILING_HEIGHT, self.__railing_height)
        
    __railing_rad1 = 0
    @property
    def railing_rad1(self):
        self.__railing_rad1 = self.__data.GetReal(ids.SMARTSTAIRS_RAILING_RAD1)
        if self.__railing_rad1 < 0: self.__railing_rad1 = 0
        return self.__railing_rad1
    @railing_rad1.setter
    def railing_rad1(self, val):
        self.__railing_rad1 = val
        self.__data.SetReal(ids.SMARTSTAIRS_RAILING_RAD1, self.__railing_rad1)
        
    __railing_rad2 = 0
    @property
    def railing_rad2(self):
        self.__railing_rad2 = self.__data.GetReal(ids.SMARTSTAIRS_RAILING_RAD2)
        if self.__railing_rad2 < 0: self.__railing_rad2 = 0
        return self.__railing_rad2
    @railing_rad2.setter
    def railing_rad2(self, val):
        self.__railing_rad2 = val
        self.__data.SetReal(ids.SMARTSTAIRS_RAILING_RAD2, self.__railing_rad2)
        
    __railing_offsetx = 0
    @property
    def railing_offsetx(self):
        self.__railing_offsetx = self.__data.GetReal(ids.SMARTSTAIRS_RAILING_OFFSETX)
        if self.__railing_offsetx < 0: self.__railing_offsetx = 0
        return self.__railing_offsetx
    @railing_offsetx.setter
    def railing_offsetx(self, val):
        self.__railing_offsetx = val
        self.__data.SetReal(ids.SMARTSTAIRS_RAILING_OFFSETX, self.__railing_offsetx)
        
    __railing_offsetz = 0
    @property
    def railing_offsetz(self):
        self.__railing_offsetz = self.__data.GetReal(ids.SMARTSTAIRS_RAILING_OFFSETZ)
        if self.__railing_offsetz < 0: self.__railing_offsetz = 0
        return self.__railing_offsetz
    @railing_offsetz.setter
    def railing_offsetz(self, val):
        self.__railing_offsetz = val
        self.__data.SetReal(ids.SMARTSTAIRS_RAILING_OFFSETZ, self.__railing_offsetz)
        
    __railing_overtop = 0
    @property
    def railing_overtop(self):
        self.__railing_overtop = self.__data.GetReal(ids.SMARTSTAIRS_RAILING_OVERTOP)
        if self.__railing_overtop < 0: self.__railing_overtop = 0
        return self.__railing_overtop
    @railing_overtop.setter
    def railing_overtop(self, val):
        self.__railing_overtop = val
        self.__data.SetReal(ids.SMARTSTAIRS_RAILING_OVERTOP, self.__railing_overtop)
        
    __railing_overbottom = 0
    @property
    def railing_overbottom(self):
        self.__railing_overbottom = self.__data.GetReal(ids.SMARTSTAIRS_RAILING_OVERBOTTOM)
        if self.__railing_overbottom < 0: self.__railing_overbottom = 0
        return self.__railing_overbottom
    @railing_overbottom.setter
    def railing_overbottom(self, val):
        self.__railing_overbottom = val
        self.__data.SetReal(ids.SMARTSTAIRS_RAILING_OVERBOTTOM, self.__railing_overbottom)
        
    __railing_nth = 0
    @property
    def railing_nth(self):
        self.__railing_nth = self.__data.GetLong(ids.SMARTSTAIRS_RAILING_NTH)
        if self.__railing_nth < 0: self.__railing_nth = 0
        return self.__railing_nth
    @railing_nth.setter
    def railing_nth(self, val):
        self.__railing_nth = val
        self.__data.SetLong(ids.SMARTSTAIRS_RAILING_NTH, self.__railing_nth)
        
    __railing_link = 0
    @property
    def railing_link(self):
        self.__railing_link = self.__data.GetLink(ids.SMARTSTAIRS_RAILING_LINK, self.__obj.GetDocument())
        return self.parent.railing_link if self.is_child and self.inherit_railing else self.__railing_link
    @railing_link.setter
    def railing_link(self, val):
        self.__railing_link = val
        self.__data.SetLink(ids.SMARTSTAIRS_RAILING_LINK, val)
        
    __railing_link_scale = False
    @property
    def railing_link_scale(self):
        self.__railing_link_scale = self.__data.GetBool(ids.SMARTSTAIRS_RAILING_LINKSCALE)
        return self.__railing_link_scale
    @railing_link_scale.setter
    def railing_link_scale(self, val):
        self.__railing_link_scale = val
        self.__data.SetBool(ids.SMARTSTAIRS_RAILING_LINKSCALE, self.__railing_link_scale)
        
    __railing_hlink = 0
    @property
    def railing_hlink(self):
        self.__railing_hlink = self.__data.GetLink(ids.SMARTSTAIRS_RAILING_HLINK, self.__obj.GetDocument())
        return self.parent.railing_hlink if self.is_child and self.inherit_railing else self.__railing_hlink
    @railing_hlink.setter
    def railing_hlink(self, val):
        self.__railing_hlink = val
        self.__data.SetLink(ids.SMARTSTAIRS_RAILING_HLINK, val)
        
    __railing_hlink_scale = False
    @property
    def railing_hlink_scale(self):
        self.__railing_hlink_scale = self.__data.GetBool(ids.SMARTSTAIRS_RAILING_HLINKSCALE)
        return self.__railing_hlink_scale
    @railing_hlink_scale.setter
    def railing_hlink_scale(self, val):
        self.__railing_hlink_scale = val
        self.__data.SetBool(ids.SMARTSTAIRS_RAILING_HLINKSCALE, self.__railing_hlink_scale)

    __platform_direction = 0
    @property
    def platform_direction(self):
        self.__platform_direction = self.__data.GetLong(ids.SMARTSTAIRS_PLATFORM_DIRECTION)
        return self.__platform_direction
    @platform_direction.setter
    def platform_direction(self, val):
        self.__platform_direction = val
        self.__data.SetLong(ids.SMARTSTAIRS_PLATFORM_DIRECTION, self.__platform_direction)

    __platform_width = 0
    @property
    def platform_width(self):
        self.__platform_width = self.__data.GetReal(ids.SMARTSTAIRS_PLATFORM_WIDTH)
        if self.__platform_width < 0: self.__platform_width = 0
        return self.__platform_width
    @platform_width.setter
    def platform_width(self, val):
        self.__platform_width = val
        self.__data.SetReal(ids.SMARTSTAIRS_PLATFORM_WIDTH, self.__platform_width)

    __platform_depth = 0
    @property
    def platform_depth(self):
        self.__platform_depth = self.__data.GetReal(ids.SMARTSTAIRS_PLATFORM_DEPTH)
        if self.__platform_depth < 0: self.__platform_depth = 0
        return self.__platform_depth
    @platform_depth.setter
    def platform_depth(self, val):
        self.__platform_depth = val
        self.__data.SetReal(ids.SMARTSTAIRS_PLATFORM_DEPTH, self.__platform_depth)    
    
    __inherit_materials = False
    @property
    def inherit_materials(self):
        self.__inherit_materials = self.__data.GetBool(ids.SMARTSTAIRS_MATERIALS_INHERIT)
        return self.__inherit_materials
    @inherit_materials.setter
    def inherit_materials(self, val):
        self.__inherit_materials = val
        self.__data.SetBool(ids.SMARTSTAIRS_MATERIALS_INHERIT, self.__inherit_materials)        
        
    __mat_linkbase = False
    @property
    def mat_linkbase(self):
        self.__mat_linkbase = self.__data.GetLink(ids.SMARTSTAIRS_MATERIALS_BASELINK, self.__obj.GetDocument())
        return self.parent.mat_linkbase if self.is_child and self.inherit_materials else self.__mat_linkbase
    @mat_linkbase.setter
    def mat_linkbase(self, val):
        self.__mat_linkbase = val
        self.__data.SetLink(ids.SMARTSTAIRS_MATERIALS_BASELINK, val)
        
    __treads_link = False
    @property
    def mat_linkstep(self):
        self.__mat_linkstep = self.__data.GetLink(ids.SMARTSTAIRS_MATERIALS_STEPLINK, self.__obj.GetDocument())
        return self.parent.mat_linkstep if self.is_child and self.inherit_materials else self.__mat_linkstep
    @mat_linkstep.setter
    def mat_linkstep(self, val):
        self.__mat_linkstep = val
        self.__data.SetLink(ids.SMARTSTAIRS_MATERIALS_STEPLINK, val)
        
    __mat_linkplatform = False
    @property
    def mat_linkplatform(self):
        self.__mat_linkplatform = self.__data.GetLink(ids.SMARTSTAIRS_MATERIALS_PLATFORMLINK, self.__obj.GetDocument())
        return self.parent.mat_linkplatform if self.is_child and self.inherit_materials else self.__mat_linkplatform
    @mat_linkplatform.setter
    def mat_linkplatform(self, val):
        self.__mat_linkplatform = val
        self.__data.SetLink(ids.SMARTSTAIRS_MATERIALS_PLATFORMLINK, val)
        
    __mat_linkrailing = False
    @property
    def mat_linkrailing(self):
        self.__mat_linkrailing = self.__data.GetLink(ids.SMARTSTAIRS_MATERIALS_RAILINGLINK, self.__obj.GetDocument())
        return self.parent.mat_linkrailing if self.is_child and self.inherit_materials else self.__mat_linkrailing
    @mat_linkrailing.setter
    def mat_linkrailing(self, val):
        self.__mat_linkrailing = val
        self.__data.SetLink(ids.SMARTSTAIRS_MATERIALS_RAILINGLINK, val)
        
    __mat_handrail = False
    @property
    def mat_handrail(self):
        self.__mat_handrail = self.__data.GetLink(ids.SMARTSTAIRS_MATERIALS_HANDRAILLINK, self.__obj.GetDocument())
        return self.parent.mat_handrail if self.is_child and self.inherit_materials else self.__mat_handrail
    @mat_handrail.setter
    def mat_handrail(self, val):
        self.__mat_handrail = val
        self.__data.SetLink(ids.SMARTSTAIRS_MATERIALS_HANDRAILLINK, val)      
      
        
    __stair_dims = c4d.Vector()
    @property
    def stair_dims(self):
        self.__stair_dims = c4d.Vector(self.width, self.height, self.depth)
        return self.__stair_dims
    @stair_dims.setter
    def stair_dims(self, val):
        self.width  = val.x
        self.height = val.y
        self.depth  = val.z
        self.__stair_dims = val

    __step_dims = c4d.Vector()
    @property
    def step_dims(self):
        self.__step_dims = c4d.Vector(self.width, self.height / self.num_steps, self.depth / self.num_steps)
        if self.__stairtype == ids.SMARTSTAIRS_STAIRS_TYPE_HELIX:
            self.__step_dims.x = self.width / 2.0
            self.__step_dims.z = self.treads_depth
        return self.__step_dims
    @step_dims.setter
    def step_dims(self, val):
        self.__step_dims = val

    __platform_dims = c4d.Vector()
    @property
    def platform_dims(self):
        self.__platform_dims = c4d.Vector(self.width, self.step_dims.y, self.platform_depth)
        return self.__platform_dims
    @platform_dims.setter
    def platform_dims(self, val):
        self.__platform_dims = val


    def __init__(self, aObj):

        self.__obj = aObj
        self.__data = self.__obj.GetDataInstance()


    def setDefaults(self):

        self.width                  = config.SMARTSTAIRS_STAIRS_WIDTH_DEFAULT
        self.height                 = config.SMARTSTAIRS_STAIRS_HEIGHT_DEFAULT
        self.depth                  = config.SMARTSTAIRS_STAIRS_DEPTH_DEFAULT
        
        self.use_step_dims          = config.SMARTSTAIRS_STAIRS_USESTEPDIMS_DEFAULT

        self.num_steps              = config.SMARTSTAIRS_STAIRS_NUM_DEFAULT

        self.reverse                = config.SMARTSTAIRS_STAIRS_REVERSE_DEFAULT
        
        self.stair_anchor           = config.SMARTSTAIRS_STAIRS_ANCHOR_DEFAULT
        
        self.inherit_type           = config.SMARTSTAIRS_TYPE_INHERIT_DEFAULT

        self.stairtype              = config.SMARTSTAIRS_STAIRS_TYPE_DEFAULT
        
        self.stair_zigzag           = config.SMARTSTAIRS_STAIRS_ZIGZAG_DEFAULT
        self.stair_tobottom         = config.SMARTSTAIRS_STAIRS_TOBOTTOM_DEFAULT
        self.stair_bottomoffset     = config.SMARTSTAIRS_STAIRS_BOTTOMOFFSET_DEFAULT
        
        self.stair_helix_deg        = config.SMARTSTAIRS_STAIRS_HELIX_DEG_DEFAULT
        self.stair_helix_innerrad   = config.SMARTSTAIRS_STAIRS_HELIX_INRAD_DEFAULT
        self.stair_helix_hascyl     = config.SMARTSTAIRS_STAIRS_HELIX_HASCYL_DEFAULT
        self.stair_helix_cylrad     = config.SMARTSTAIRS_STAIRS_HELIX_CYLRAD_DEFAULT

        self.base_width             = config.SMARTSTAIRS_STAIRS_BASEWIDTH_DEFAULT
        self.base_height            = config.SMARTSTAIRS_STAIRS_BASEHEIGHT_DEFAULT
        self.base_distance          = config.SMARTSTAIRS_STAIRS_BASEDISTANCE_DEFAULT

        self.inherit_treads         = config.SMARTSTAIRS_TREADS_INHERIT_DEFAULT
        self.has_treads             = config.SMARTSTAIRS_STAIRS_HASTREADS_DEFAULT
        self.has_railing              = config.SMARTSTAIRS_STAIRS_HASRAILING_DEFAULT

        self.treads_height          = config.SMARTSTAIRS_TREADS_HEIGHT_DEFAULT
        self.treads_depth           = config.SMARTSTAIRS_TREADS_DEPTH_DEFAULT
        self.treads_offset_z        = config.SMARTSTAIRS_TREADS_OFFSETZ_DEFAULT
        self.treads_offset_y        = config.SMARTSTAIRS_TREADS_OFFSETY_DEFAULT
        self.treads_have_fillet     = config.SMARTSTAIRS_TREADS_HASFILLET_DEFAULT
        self.treads_fillet_rad      = config.SMARTSTAIRS_TREADS_FILLETRAD_DEFAULT
        self.treads_fillet_sub      = config.SMARTSTAIRS_TREADS_FILLETSUB_DEFAULT
        self.treads_link_scale      = config.SMARTSTAIRS_TREADS_LINKSCALE_DEFAULT
        
        self.inherit_railing        = config.SMARTSTAIRS_RAILING_INHERIT_DEFAULT
        
        self.railing_type           = config.SMARTSTAIRS_RAILING_TYPE_DEFAULT
        self.railing_height         = config.SMARTSTAIRS_RAILING_HEIGHT_DEFAULT
        self.railing_rad1           = config.SMARTSTAIRS_RAILING_RAD1_DEFAULT
        self.railing_rad2           = config.SMARTSTAIRS_RAILING_RAD2_DEFAULT
        self.railing_offsetx        = config.SMARTSTAIRS_RAILING_OFFSETX_DEFAULT
        self.railing_offsetz        = config.SMARTSTAIRS_RAILING_OFFSETZ_DEFAULT
        self.railing_overtop        = config.SMARTSTAIRS_RAILING_OVERTOP_DEFAULT
        self.railing_overbottom     = config.SMARTSTAIRS_RAILING_OVERBOTTOM_DEFAULT
        self.railing_nth            = config.SMARTSTAIRS_RAILING_NTH_DEFAULT
        self.railing_link_scale     = config.SMARTSTAIRS_RAILING_LINKSCALE_DEFAULT
        self.railing_hlink_scale    = config.SMARTSTAIRS_RAILING_HLINKSCALE_DEFAULT

        self.platform_direction     = config.SMARTSTAIRS_PLATFORM_DIRECTION_DEFAULT
        self.platform_width         = config.SMARTSTAIRS_PLATFORM_WIDTH_DEFAULT
        self.platform_depth         = config.SMARTSTAIRS_PLATFORM_DEPTH_DEFAULT
        
        self.inherit_materials      = config.SMARTSTAIRS_MATERIALS_INHERIT_DEFAULT
        
         
    def setRandom(self, aType):
        
        if aType == 0:
            self.width                  = random.randint(-1000, 1000)
            self.height                 = random.randint(-1000, 1000)
            self.depth                  = random.randint(-1000, 1000)        
            self.use_step_dims          = random.randint(0, 1)
            self.num_steps              = random.randint(-100, 100)
            self.reverse                = random.randint(0, 1)        
            self.stair_anchor           = random.choice([ids.SMARTSTAIRS_STAIRS_ANCHOR_BACK,
                                                         ids.SMARTSTAIRS_STAIRS_ANCHOR_CENTER,
                                                         ids.SMARTSTAIRS_STAIRS_ANCHOR_FRONT])        
            self.inherit_type           = random.randint(0, 1)
            self.stairtype              = random.choice([ids.SMARTSTAIRS_STAIRS_TYPE_TREADS,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_STD,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_SINGLE,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_SOLID,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_DOUBLE,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_DOUBLE2,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_DOUBLE3,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_HELIX])        
            self.stair_zigzag           = random.randint(0, 1)
            self.stair_tobottom         = random.randint(0, 1)
            self.stair_bottomoffset     = random.randint(-1000, 1000)        
            self.stair_helix_deg        = random.randint(-100, 100)
            self.stair_helix_innerrad   = random.randint(-1000, 1000)
            self.stair_helix_hascyl     = random.randint(0, 1)
            self.stair_helix_cylrad     = random.randint(-1000, 1000)
            self.base_width             = random.randint(-100, 100)
            self.base_height            = random.randint(-100, 100)
            self.base_distance          = random.randint(-100, 100)
            self.inherit_treads         = random.randint(0, 1)
            self.has_treads             = random.randint(0, 1)
            self.has_railing            = random.randint(0, 1)
            self.treads_height          = random.randint(-100, 100)
            self.treads_depth           = random.randint(-100, 100)
            self.treads_offset_z        = random.randint(-100, 100)
            self.treads_offset_y        = random.randint(-100, 100)
            self.treads_have_fillet     = random.randint(0, 1)
            self.treads_fillet_rad      = random.randint(-100, 100)
            self.treads_fillet_sub      = config.SMARTSTAIRS_TREADS_FILLETSUB_DEFAULT
            self.treads_link_scale      = random.randint(0, 1)        
            self.inherit_railing        = random.randint(0, 1)        
            self.railing_type           = random.choice([ids.SMARTSTAIRS_RAILING_TYPE_BOTH,
                                                         ids.SMARTSTAIRS_RAILING_TYPE_LEFT,
                                                         ids.SMARTSTAIRS_RAILING_TYPE_RIGHT])        
            self.railing_height         = random.randint(-100, 100)
            self.railing_rad1           = random.randint(-100, 100)
            self.railing_rad2           = random.randint(-100, 100)
            self.railing_offsetx        = random.randint(-100, 100)
            self.railing_offsetz        = random.randint(-100, 100)
            self.railing_overtop        = random.randint(-100, 100)
            self.railing_overbottom     = random.randint(-100, 100)
            self.railing_nth            = random.randint(-10, 10)
            self.railing_link_scale     = random.randint(0, 1)
            self.railing_hlink_scale    = random.randint(0, 1)
            self.platform_direction     = random.choice([ids.SMARTSTAIRS_PLATFORM_DIR_FRONT,
                                                         ids.SMARTSTAIRS_PLATFORM_DIR_LEFT,
                                                         ids.SMARTSTAIRS_PLATFORM_DIR_RIGHT,
                                                         ids.SMARTSTAIRS_PLATFORM_DIR_ULEFT,
                                                         ids.SMARTSTAIRS_PLATFORM_DIR_URIGHT])        
            self.platform_width         = random.randint(-1000, 1000)
            self.platform_depth         = random.randint(-1000, 1000)        
            self.inherit_materials      = random.randint(0, 1)
            
        if aType == 1:
            self.width                  = random.randint(50, 200)
            self.height                 = random.randint(50, 200)
            self.depth                  = random.randint(50, 200)        
            self.use_step_dims          = random.randint(0, 1)
            self.num_steps              = random.randint(5, 25)
            self.reverse                = random.randint(0, 1)        
            self.stair_anchor           = random.choice([ids.SMARTSTAIRS_STAIRS_ANCHOR_BACK,
                                                         ids.SMARTSTAIRS_STAIRS_ANCHOR_CENTER,
                                                         ids.SMARTSTAIRS_STAIRS_ANCHOR_FRONT])        
            self.inherit_type           = random.randint(0, 1)
            self.stairtype              = random.choice([ids.SMARTSTAIRS_STAIRS_TYPE_TREADS,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_STD,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_SINGLE,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_SOLID,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_DOUBLE,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_DOUBLE2,
                                                         ids.SMARTSTAIRS_STAIRS_TYPE_DOUBLE3])        
            self.stair_zigzag           = random.randint(0, 1)
            self.stair_tobottom         = random.randint(0, 1)
            self.stair_bottomoffset     = random.randint(0, 100)        
            self.stair_helix_deg        = random.randint(-10, 10)
            self.stair_helix_innerrad   = random.randint(0, 100)
            self.stair_helix_hascyl     = random.randint(0, 1)
            self.stair_helix_cylrad     = random.randint(0, 100)
            self.base_width             = random.randint(10, 50)
            self.base_height            = random.randint(10, 50)
            self.base_distance          = random.randint(10, 50)
            self.inherit_treads         = random.randint(0, 1)
            self.has_treads             = random.randint(0, 1)
            self.has_railing            = random.randint(0, 1)
            self.treads_height          = random.randint(0, 100)
            self.treads_depth           = random.randint(0, 100)
            self.treads_offset_z        = random.randint(0, 10)
            self.treads_offset_y        = random.randint(0, 10)
            self.treads_have_fillet     = random.randint(0, 1)
            self.treads_fillet_rad      = random.randint(0, 4)
            self.treads_fillet_sub      = config.SMARTSTAIRS_TREADS_FILLETSUB_DEFAULT
            self.treads_link_scale      = random.randint(0, 1)        
            self.inherit_railing        = random.randint(0, 1)        
            self.railing_type           = random.choice([ids.SMARTSTAIRS_RAILING_TYPE_BOTH,
                                                         ids.SMARTSTAIRS_RAILING_TYPE_LEFT,
                                                         ids.SMARTSTAIRS_RAILING_TYPE_RIGHT])        
            self.railing_height         = random.randint(0, 100)
            self.railing_rad1           = random.randint(0, 3)
            self.railing_rad2           = random.randint(0, 3)
            self.railing_offsetx        = random.randint(0, 10)
            self.railing_offsetz        = random.randint(0, 10)
            self.railing_overtop        = random.randint(0, 50)
            self.railing_overbottom     = random.randint(0, 50)
            self.railing_nth            = random.randint(0, 10)
            self.railing_link_scale     = random.randint(0, 1)
            self.railing_hlink_scale    = random.randint(0, 1)
            self.platform_direction     = random.choice([ids.SMARTSTAIRS_PLATFORM_DIR_FRONT,
                                                         ids.SMARTSTAIRS_PLATFORM_DIR_LEFT,
                                                         ids.SMARTSTAIRS_PLATFORM_DIR_RIGHT,
                                                         ids.SMARTSTAIRS_PLATFORM_DIR_ULEFT,
                                                         ids.SMARTSTAIRS_PLATFORM_DIR_URIGHT])        
            self.platform_width         = random.randint(50, 200)
            self.platform_depth         = random.randint(50, 200)        
            self.inherit_materials      = random.randint(0, 1)
        
        if self.child is not None:
            self.child.setRandom(aType)