# -*- coding: utf-8 -*-

import sys
import os
import time
import traceback

from c4d import gui
from c4d import storage

from smartstairspackage.utils import hivemind

from smartstairspackage import ids


def exceptionHook(aType, aValue, aTb):

    exarr = traceback.format_exception(aType, aValue, aTb)
    if "smartstairspackage" in str(exarr):
        outp = ""
        for itm in exarr:
            outp += itm
        trace(outp, False, True)
    else:
        traceback.print_exception(aType, aValue, aTb)


def throwUp(a, doTrace=True, aException = True):

    gui.MessageDialog("(Smart Stairs)\n\n" + a)

    if doTrace:
        trace(a, False, False, aException)


def trace(a, aDoTrace = True, aWrite = False, aException = True):

    if a is None: return
    
    line1 = "-" *50*2 + "\n"
    line2 = "=" *50 + "\n"
    
    outp = ""
    
    if a.__class__.__name__ == "list":
        tmp = ""
        if aException:
            tmp = "exception input-type was list...\n"
        tmp += line1
        for i, value in enumerate(a):
            tmp+= "line " + str(i) + " : " + str(value) + "\n"
        a = tmp[0:-2]
    
    if a.__class__.__name__ == "dict":
        tmp = ""
        if aException:
            tmp = "exception input-type was dictionary...\n"
        tmp += line1
        for key, value in dict.items(a):
            tmp+= str(key) + " : " + str(value) + "\n"
        a = tmp[0:-2]
    
    exc_type, exc_value, exc_traceback = sys.exc_info()
    outp += line2
    if aException:
        outp += "    ::ERROR:: (Plugin ID: " + str(ids.PLUGIN_ID) + ")\n"
    else:
        outp += "    ::OUTPUT:: (Plugin ID: " + str(ids.PLUGIN_ID) + ")\n"
    outp += line1
    outp += time.asctime(time.localtime(time.time())) + "\n"
    outp += line1
    outp += a + "\n"
    
    if aDoTrace:
        outp += "Traceback:"
        outp += str().join(n for n in traceback.format_exception(exc_type, exc_value, exc_traceback)).rpartition("\n")[0]
        
    outp += "\n" + line2
    
    if not "\n" in outp:
        print(outp)
    else:
        lines = outp.split('\n')
        for line in lines:
            print(line)
    
    if aWrite:
        appendToErrorlog("\n" + outp)
        print(line2)
        
        
def appendToErrorlog(a):
    
    try:
        path = os.path.join(storage.GeGetStartupWritePath() + "/plugins/", "smartstairs_errorlog.txt")        
        fn = open(path, 'a')
        
        fn.write(a + "\n")
        fn.close()
        
        print("errorlog has been saved at: %s" % path)
    except:
        print("errorlog could not be saved - sorry!")
        
    if hasattr(hivemind.Borg(), "errorCallBack") and hivemind.Borg().errorCallBack is not None:
        hivemind.Borg().errorCallBack(a)